# NonfungibleTokenPositionDescriptor

Produces a string containing the data URI for a JSON metadata string

### Functions[​](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#functions) <a href="#functions" id="functions"></a>

#### constructor[​](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#constructor) <a href="#constructor" id="constructor"></a>

```solidity
  function constructor(
  ) public
```

#### tokenURI[​](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#tokenuri) <a href="#tokenuri" id="tokenuri"></a>

```solidity
  function tokenURI(
    contract INonfungiblePositionManager positionManager,
    uint256 tokenId
  ) external returns (string)
```

Produces the URI describing a particular token ID for a position manager

Note this URI may be a data: URI with the JSON contents directly inlined

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#parameters)

| Name              | Type                                 | Description                                                                    |
| ----------------- | ------------------------------------ | ------------------------------------------------------------------------------ |
| `positionManager` | contract INonfungiblePositionManager | The position manager for which to describe the token                           |
| `tokenId`         | uint256                              | The ID of the token for which to produce a description, which may not be valid |

**Return Values:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#return-values)

| Name  | Type                                 | Description                          |
| ----- | ------------------------------------ | ------------------------------------ |
| `The` | contract INonfungiblePositionManager | URI of the ERC721-compliant metadata |

#### flipRatio[​](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#flipratio) <a href="#flipratio" id="flipratio"></a>

```solidity
  function flipRatio(
  ) public returns (bool)
```

#### tokenRatioPriority[​](https://docs.uniswap.org/contracts/v3/reference/periphery/NonfungibleTokenPositionDescriptor#tokenratiopriority) <a href="#tokenratiopriority" id="tokenratiopriority"></a>

```solidity
  function tokenRatioPriority(
  ) public returns (int256)

```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/periphery/nonfungibletokenpositiondescriptor.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
